const app = getApp();
class HttpBasics {
  headers = {
    "Content-Type": "application/json;charset=UTF-8",
    token: ""
  };
  /**
   * 设置token
   * @param {*} token
   */
  setToken(token) {
    this.headers.token = token;
  }
  /**
   * 设置bUserId
   */
  setBUserId(bUserId){
    this.headers.bid = bUserId;
  }
  /**
   * 获取数据
   * @param {url,data,headers} param0
   */
  get({ url, data, headers }) {
    headers = { ...this.headers, ...headers };
    url = `${url}`;
    // tt.showLoading({
    //     title: 'loading...',
    // })
    return new Promise((resolve, reject) => {
      tt.request({
        url: url,
        header: headers,
        data: data,
        method: "get",
        success: res => {
          // tt.hideLoading();
          this.responseMap(res, resolve, reject);
        },
        fail: err => {
          // tt.hideLoading();
          console.log(err)
          if (err.errMsg == 'request:fail timeout') {
            err.errMsg = '请求超时，请检查您的网络设置！'
          } else if (err.errMsg == 'request:fail '){
            err.errMsg = '未检查到您的网络，请检查您的网络设置！'
          }
          reject(err);
        }
      });
    });
  }
  /**
   * 提交数据
   * @param {url,data,headers} param0
   */
  post({ url, data, headers }) {
    headers = { ...this.headers, ...headers };
    url = `${url}`;
    // tt.showLoading({
    //     title: 'loading...',
    // })
    return new Promise((resolve, reject) => {
      tt.request({
        url: url,
        header: headers,
        data: data,
        method: "POST",
        success: res => {
          tt.hideLoading();
          this.responseMap(res, resolve, reject);
        },
        fail: err => {
          // tt.hideLoading();
          if (err.errMsg == 'request:fail timeout') {
            err.errMsg = '请求超时，请检查您的网络设置！'
          } else if (err.errMsg == 'request:fail ') {
            err.errMsg = '未检查到您的网络，请检查您的网络设置！'
          }
          reject(err);
        },
        complete: res => {}
      });
    });
  }
  /**
   * 过滤 请求信息
   * @param {*} res
   * @param {*} resolve
   * @param {*} reject
   */
  responseMap = (res, resolve, reject) => {
    // 网络状态码200
    if (res.statusCode == 200) {
      // 服务器code 200 成功
      if (res.data.code == 200) {
        resolve(res.data);
      } else if (res.data.code == 1052) {
        tt.reLaunch({
          url: '/pages/main/main'
        })
      } else {
        reject(res.data);
      }
    } 
    else {
      console.log("请求出错：", res);
      reject(res.data);
    }
  };
  /** 日志 */
  log(url, body, headers) {}
}
module.exports = new HttpBasics();
